/* VMS_LNMDEF.C -- 03-JAN-1998 Uwe Zessin
   (copied from VMS_JPIDEF.C -- version 17-NOV-1996)
*/

#include "python.h"

#include "vmsdef.h"
/* reference to translation table for LNM$_name text/code */
extern struct vmsdef_xr_itmtbl VMSDEF_GR_$LNMDEF[];
/* current VMS version */
extern vmsdef_xw_vmsver vmsdef_gw_vmsver;

/* ------------------------------------------------------------------------- */
static char vms_lnmdef_doc__ [] =
"This module provides data definitions for logical name handling.";

/* ------------------------------------------------------------------------- */

static struct PyMethodDef vms_lnmdef_methods[] = {
	{NULL,			NULL}
};

/* list of $xxxDEF */
extern struct vmsdef_xr_defdirtbl VMSDEF_GR_DIRECTORY[];

void
initvms_lnmdef()
{
	PyObject *m, *d, *x;
	long	l_trn_index;
	char*	at_itm_name;
	struct vmsdef_xr_defdirtbl * ar_defdirtbl;
	struct vmsdef_xr_conmsktbl * ar_conmsktbl;
	struct vmsdef_x_bitmsk     * ar_bitmsk; /* bitmask/constant */

	m = Py_InitModule4("vms_lnmdef",
			   vms_lnmdef_methods,
			   vms_lnmdef_doc__,
			   (PyObject *)NULL,
			   PYTHON_API_VERSION);
	d = PyModule_GetDict(m);

	/* ----- ----- ----- ----- */

	/* loop through table (in VMSDEF_$LNMDEF.MAR) */
	/* Note: not all constants/bitmasks are linked to item codes. */
	/*   a new structure (vmsdef_xr_conmsktbl) has been to point to them */

	ar_defdirtbl = &VMSDEF_GR_DIRECTORY[0];
	ar_conmsktbl = NULL;

	while (ar_defdirtbl->ar_itmtbl != NULL)
	{
	  /* look up "$LNMDEF" */
	  if (strcmp("$LNMDEF",ar_defdirtbl->at_vmsdefnam) == 0)
          {
	    /* get pointer to constants and masks */
	    ar_conmsktbl = ar_defdirtbl->ar_conmsktbl;
	    break;
	  }
	  ar_defdirtbl++;
	}	  

	if (ar_conmsktbl == NULL)
	{
	    /* item table not found */
	    printf ("%%initvms_lnmdef(): $LNMDEF in VMSDEF_GR_DIRECTORY not found\n");
	    PyErr_SetString(PyExc_LookupError, "$LNMDEF in VMSDEF_GR_DIRECTORY?");
	}
	else
	{
	  /* ar_conmsktbl contains pointer to first element */
	  while (ar_conmsktbl->ar_bitmsk != NULL)
	  {
	    ar_bitmsk = ar_conmsktbl->ar_bitmsk;

	    while (ar_bitmsk->w_vmsvermin != 0)
	    {
		/* check VMS version number */
		if ((ar_bitmsk->w_vmsvermin <=vmsdef_gw_vmsver) &&
		    (ar_bitmsk->w_vmsvermax >=vmsdef_gw_vmsver)  )
		{
		  x = PyInt_FromLong(ar_bitmsk->l_bit_value);
		  at_itm_name = ar_bitmsk->at_bit_name;
		  /* @@ check if item already in dictionary */
		  PyDict_SetItemString(d, at_itm_name, x);
		}
		ar_bitmsk++;		/* point to next bitmask element */
	    }
	    ar_conmsktbl++;		/* next bitmask/constant table */
	  } /* while (ar_conmsktbl->ar_bitmsk != NULL) */
	}
	
	/* ----- ----- ----- ----- */

	/* Check for errors */
        if (PyErr_Occurred())
                Py_FatalError("can't initialize module vms_lnmdef");
	/* ----- ----- ----- ----- */

} /* initvms_lnmdef () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_LNMDEF.C */
